#define _GLIBCXX_DEBUGx
#include <bits/stdc++.h>

using namespace std;

#define ALL(A) (A).begin(),(A).end()
#define RALL(A) (A).rbegin(), (A).rend()
#define SZ(A) int(A.size())

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

const int mod = 998244353;

int add(int a, int b ) {
    return (a + b >= mod ? a + b - mod : a + b);
}

int sub(int a, int b) {
    return (a >= b ? a - b : mod + a - b);
}

int mult(int a, int b) {
    return (int64_t(a) * b) % mod;
}

const int max_n = 5010;
int dp[max_n];

int C[max_n][max_n];

void zhfs(const vector<vector<int>>& tree, vector<char>& used, int v, int& num) {
    num += 1;
    used[v] = 1;

    for (int u: tree[v])
        if (not used[u])
            zhfs(tree, used, u, num);
}

int main() {
    #ifdef LOCAL
    freopen("input2.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    C[0][0] = 1;
    for (int i = 1; i < max_n; ++i) {
        C[i][0] = C[i][i] = 1;
        for (int j = 1; j < i; ++j)
            C[i][j] = add(C[i - 1][j], C[i - 1][j - 1]);
    }

    dp[0] = 1;

    for (int n = 1; n < max_n - 2; ++n) {
        dp[n] = 0;
        for (int k = 1; k <= n; ++k)
            dp[n] = add(dp[n], mult(dp[n - k], C[n - 1][k - 1]));
    }

    int n = input<int>();
    int k = input<int>();

    vector<int> a(n);
    for (int& elem: a)
        elem = input<int>() - 1;

    vector<vector<int>> tree(n);
    for (int i = 0; i != n - 1; ++i) {
        int v = input<int>() - 1;
        int u = input<int>() - 1;

        tree[v].push_back(u);
        tree[u].push_back(v);
    }

    vector<vector<int>> poly(1 << k, vector<int>(n + 1));

    for (int msk = 0; msk != (1 << k); ++msk) {
        vector<char> used(n, false);

        for (int i = 0; i != n; ++i)
            if ((msk & (1 << a[i])) == 0)
                used[i] = true;

        for (int i = 0; i != n; ++i)
            if (not used[i]) {
                int num = 0;
                zhfs(tree, used, i, num);

                poly[msk][num] += 1;
            }
    }

    // subset_unconvolution.

    for (int it = 0; it < k; ++it) { // unco it's bit.
        for (int msk = 0; msk != (1 << k); ++msk)
            if ((msk & (1 << it)) == 0) {
                vector<int> &a = poly[msk];
                vector<int> &b = poly[msk | (1 << it)];

                for (int i = 0; i <= n; ++i)
                    b[i] = sub(b[i], a[i]);
            }
    }

    vector<int> costs(k + 1);
    for (int i = 1; i <= k; ++i)
        costs[i] = add(costs[i - 1], (1 << (k + 1 - i)));

    vector<int> onepoly(n + 1);
    for (int msk = 1; msk != (1 << k); ++msk) {
        int pc = __builtin_popcount(msk);

        for (int i = 0; i <= n; ++i)
            onepoly[i] = add(onepoly[i], mult(poly[msk][i], costs[pc]));
    }

    int ans = 0;
    for (int the_n = 1; the_n <= n; ++the_n) {
        for (int real = 1; real <= the_n; ++real) {
            ans = add(ans, mult(onepoly[the_n], mult(C[the_n][real], dp[n - real])));
        }
    }

    cout << ans << "\n";

    return 0;
}

