
#include <bits/stdc++.h>

using namespace std;

#define ALL(A) (A).begin(),(A).end()
#define RALL(A) (A).rbegin(), (A).rend()
#define SZ(A) int(A.size())

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

void fail() {
    cout << "Keine Loesung\n";
    exit(0);
}

int main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s = input<string>();
    if (SZ(s) % 2)
        fail();

    vector<char> res;
    for (int i = 0; i < SZ(s); i += 2)
        if (s[i] != s[i + 1])
            fail();
        else
            res.push_back(s[i]);

    int n = SZ(res);
    vector<vector<char>> dp(n, vector<char>(n, false));

    for (int len = 0; len <= n - 1; ++len)
        for (int i = 0; i + len <= n - 1; ++i) {
            int j = i + len;

            if (len == 0)
                dp[i][j] = false;
            else if (len == 1)
                dp[i][j] = (res[i] != res[j]);
            else {
                if (res[i] != res[j])
                    dp[i][j] = dp[i + 1][j - 1];

                for (int mid = i; mid < j; ++mid)
                    dp[i][j] = (dp[i][j] or (dp[i][mid] and dp[mid + 1][j]));
            }
        }

    if (dp[0][n - 1] == false)
        fail();

    std::function<void(int, int)> recover = [&](int l, int r) {
        if (r - l == 1)
            cout << "[]";
        else if (res[l] != res[r] and dp[l + 1][r - 1]) {
            cout << "[";
            recover(l + 1, r - 1);
            cout << "]";
        } else {
            for (int mid = l; mid < r; ++mid)
                if (dp[l][mid] and dp[mid + 1][r]) {
                    recover(l, mid);
                    recover(mid + 1, r);
                    return;
                }
            assert(false);
        }
    };

    recover(0, n - 1);

    return 0;
}

