#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using namespace std;
typedef long long ll;
typedef pair <int, int> par;
int const mod = 998244353;
int const N = 50100;
int const INF = 1e9;

vector <par> g[N];
vector <bool> used, source;
vector <int> tsort;
vector <char> color;
int dp[N][3];
int id[300];
char ch[5];

void topsort(int i) {
	used[i] = true;
	for (par to : g[i]) if (!used[to.first]) topsort(to.first);
	tsort.push_back(i);
}

int lft;

void paint (int v, par cur, int id = 0) {
	used[v] = true;
	for (par to : g[v]) if (!color[to.second]) {
		lft--;
		if (id) color[to.second] = ch[cur.second]; else color[to.second] = ch[cur.first];
		if (!used[to.first]) paint(to.first, cur, id ^ 1);
	}
}

/*
bool paint(int v, bool e) {
	for (par to : g[v]) {
		int c;
		do {
			c = rand() % 3;
		} while (min(min(dp[to.first][0], dp[to.first][1]), dp[to.first][2]) < dp[to.first][c]);
		if (rand() % 8 < 3) c = rand() % 3;
		if (e) {
			c = rand() % 3;
		}
		color[to.second] = ch[c];
		dp[v][c] = max(dp[v][c], dp[to.first][c] + 1);
		if (dp[v][c] == 42) {
			return false;
		}
	}
	return true;
}
*/
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	ios::sync_with_stdio(false);
	id['R'] = 0;
	id['G'] = 1;
	id['B'] = 2;
	ch[0] = 'R';
	ch[1] = 'G';
	ch[2] = 'B';
	int n, m;
	cin >> n >> m;
	source.assign(n, true);
	for (int i = 0; i < m; i++) {
		int v, w;
		cin >> v >> w;
		v--; w--;
		g[v].push_back({ w, i });
		source[w] = false;
	}
	used.assign(n, false);
	for (int i = 0; i < n; i++) if (source[i]) {
		topsort(i);
	}
	reverse(tsort.begin(), tsort.end());
	lft = m;
	color.assign(m, 0);
	for (int i = 0; i < m; i++) {
		if (rand() % 2) {
			color[i] = ch[rand() % 3];
			lft--;
		}
	} while (lft) {
		used.assign(n, 0);
		par cur = { rand() % 3, rand() % 3 };
		while (cur.first == cur.second) cur.second = rand() % 3;
		for (int i = 0; i < n; i++) if (!used[tsort[i]]) {
			paint(tsort[i], cur);
		}
	}
	for (int i = 0; i < m; i++) cout << color[i] << '\n';
	return 0;
}