#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using namespace std;
typedef long long ll;
typedef pair <int, int> par;
int const mod = 998244353;
int const N = 50100;
int const INF = 1e9;

vector <par> g[N];
vector <bool> used, source;
vector <int> tsort;
vector <char> color;
int dp[N][3];
int id[300];
char ch[5];

void topsort(int i) {
	used[i] = true;
	for (par to : g[i]) if (!used[to.first]) topsort(to.first);
	tsort.push_back(i);
}

void paint(int v) {
	int mx[3] = { 0, 0, 0 };
	for (int c = 0; c < 3; c++) {
		for (par to : g[v]) {
			mx[c] = max(mx[c], dp[to.first][c]);
		}
	}
	int mn = mx[0], id = 0;
	for (int i = 1; i < 3; i++) if (mn > mx[i]) {
		mn = mx[i]; id = i;
	}
	for (par to : g[v]) {
		color[to.second] = ch[id];
		dp[v][id] = max(dp[v][id], dp[to.first][id] + 1);
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	ios::sync_with_stdio(false);
	id['R'] = 0;
	id['G'] = 1;
	id['B'] = 2;
	ch[0] = 'R';
	ch[1] = 'G';
	ch[2] = 'B';
	int n, m;
	cin >> n >> m;
	source.assign(n, true);
	for (int i = 0; i < m; i++) {
		int v, w;
		cin >> v >> w;
		v--; w--;
		g[v].push_back({ w, i });
		source[w] = false;
	}
	used.assign(n, false);
	for (int i = 0; i < n; i++) if (source[i]) {
		topsort(i);
	}
	color.assign(m, 0);
	for (int i : tsort) paint(i);
	for (int i = 0; i < m; i++) cout << color[i] << '\n';
	return 0;
}