#include <iostream>
#include <algorithm>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <random>
#include <set>
#include <map>

using namespace std;
mt19937 gen(time(NULL));
const int N = 50050, M = 200500;

#pragma gcc optimize("O3")

#define all(x) x.begin(), x.end()
#define mp make_pair
#define pii pair<int, int>
#define forn(i, n) for (int i = 0; i < n; i++)

typedef long long ll;

const int mod = 1e9 + 9;
const int mod2 = 1e9 + 7;

void mod_add(int& u, int v, int mod) {
	u += v;
	if (u >= mod) u -= mod;
}

int p[N];
int hs[N];
int p2[N], hs2[N];

int P = 23917, P2 = 239017;

inline int mod_mul(int u, int v, int mod) {
	return (u * 1LL * v) % mod;
}

inline pair<int, int> get_hash(int l, int r) {
	return mp((hs[r] + mod - mod_mul(hs[l], p[r - l], mod)) % mod, (hs2[r] + mod2 - mod_mul(hs2[l], p2[r - l], mod2)) % mod2);
}

void pre(string &s) {
	int n = s.length();
	p[0] = 1;
	p2[0] = 1;
	for (int i = 1; i <= n; i++) {
		hs[i] = mod_mul(hs[i - 1], P, mod);
		p[i] = mod_mul(p[i - 1], P, mod);
		mod_add(hs[i], s[i - 1], mod);
		hs2[i] = mod_mul(hs2[i - 1], P2, mod2);
		p2[i] = mod_mul(p2[i - 1], P2, mod2);
		mod_add(hs2[i], s[i - 1], mod2);
	}
}

vector<pii> len[5050];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	string s;
	cin >> s;

	int k = s.length();
	int n;
	cin >> n;

	s = s + s + s + s + s;
	pre(s);

	if (n <= 4 * k) {
		for (int i = 0; i < n; i++)
			for (int j = i + 1; j <= n; j++) {
				len[j - i].push_back(get_hash(i, j));
			}

		ll ans = 0;
		for (int i = 1; i <= n; i++) {
			sort(all(len[i]));
			len[i].erase(unique(all(len[i])), len[i].end());
			ans += len[i].size();
		}
		cout << ans << endl;
		return 0;
	}

	for (int i = 0; i < 5 * k; i++)
		for (int l = 1; l <= min(3 * k, 5 * k - i); l++)
			len[l].push_back(get_hash(i, i + l));

	ll ans = 0;
	for (int i = 1; i <= 3 * k; i++) {
		sort(all(len[i]));
		len[i].erase(unique(all(len[i])), len[i].end());
		ans += len[i].size();
	}

	int leftover = n % k;

	// Prefix - 1 .. k
	// Suffix - 1 .. leftover
	// Length - (3k, 4k]
	map<pii, int> equers;
	for (int i = 1; i <= k; i++) {
		for (int j = 1; j <= k; j++) {
			if (i + j <= k) {
				auto& x = equers[get_hash(k - i, 4 * k + j)];
				if (j <= leftover)
					x = max(x, n / k - 3);
				else
					x = max(x, n / k - 4);
			}
			else {
				auto& x = equers[get_hash(k - i, 3 * k + j)];
				if (j <= leftover)
					x = max(x, n / k - 2);
				else
					x = max(x, n / k - 3);
			}
		}
	}

	for (auto elem : equers) ans += elem.second;

	cout << ans << endl;
	return 0;
}
