#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define int long long

using namespace std;

const int M = 1e9 + 7, b = 31, N = 1000 + 10;

int h[N * 5];
int p[N * 5];

int get(int l, int r) {
    return (h[r] - (1LL * h[l] * p[r - l]) % M + M) % M;
}

void calc_hash(string s) {
    forn(i, s.size()) {
        h[i + 1] = (1LL * h[i] * b + s[i] - 'a' + 1) % M;
    }
    p[0] = 1;
    forn(i, N * 5) {
        p[i + 1] = (1LL * p[i] * b) % M;
    }
}



unordered_set<int> dist[4 * N];
unordered_set<int> sufpref[4 * N];

void wipe() {
	for(int i = 0; i < 5 * N; i++) {
		h[i] = p[i] = 0;
	}
	for(int i = 0; i < 4 * N; i++)
        dist[i].clear();
}

int get_dist(string s) {
	wipe();
	calc_hash(s);
	int n = s.size();
	for(int i = 0; i < n; i++) {
		for(int j = i + 1; j <= n; j++) {
			dist[j - i].insert(get(i, j));
			//cerr << get(i, j) << '\n';
		}
	}
	int res = 0;
	for(int len = 1; len <= n; len++) {
		res += dist[len].size();
	}
	return res;
}
int get_dist2(string s) {
    s += s;
	wipe();
	calc_hash(s);
	int n = s.size();
	for(int i = 0; i < n; i++) {
		for(int j = i + 1; j <= n; j++) {
			dist[j - i].insert(get(i, j));
			//cerr << get(i, j) << '\n';
		}
	}
	int res = 0;
	for(int len = 1; len <= n / 2; len++) {
		res += dist[len].size();
	}
	return res;
}

int get_sufpref(string s, int minpref, int maxpref, int minsuf, int maxsuf, int minsum, int maxsum, int k) {
	for(int i = 0; i < 4* N; i++) {
		sufpref[i].clear();
	}
	int n = s.size();
	for(int i = 0; i < k; i++)
        s += s;
	wipe();
	calc_hash(s);
	for(int p = minpref; p <= maxpref; p++) {
		for(int s = minsuf; s <= maxsuf; s++) {
			if(p + s <= maxsum && p + s >= minsum) {
				sufpref[p + s].insert(get(n - p, k * n + s));
			}
		}
	}
	int res = 0;
	for(int len = minsum; len <= maxsum; len++) {
		res += sufpref[len].size();
	}
	return res;
}

long long slow(string s, int k, int n) {
    string tmp = s;
    while(tmp.size() < n)
        tmp += s;
    tmp = tmp.substr(0, n);
    return get_dist(tmp);
}


signed main()
{
	string s;
	cin >> s;
	int n;
	cin >> n;
	int k = s.size();
	//cout << slow(s, k, n) << '\n';
	if(n <= 4 * k) {
		cout << slow(s, k, n) << '\n';
	}
	else {
		long long res = get_dist2(s);
		//cerr << sp << "\n";
		//cerr << res << "\n";
		int block = n / k;
		//if(n % k == 0) {
            //cerr <<    get_sufpref(s, 0, k, 0, k, k + 1, 2 * k) << "\n";
			res += (block - 2) * get_sufpref(s, 0, k, 0, k, 1, k, 2) + get_sufpref(s, 0, k, 0, k + n % k, k + 1, 2 * k + n % k, 4);
		//}
		/*
		else {
            res += sp + (block - 2) * get_sufpref(s, 0, k, 0, k, 1, k) + get_sufpref(s, 0, k, 0, k, k + 1, 2 * k);
        cerr << get_sufpref(s, 0, k, 0, n % k, k + 1, k + n % k) << "\n";
			res += get_sufpref(s, 0, k, 0, n % k, k + 1, k + n % k);
		}
		*/
		cout << res << "\n";
	}
    return 0;
}
