#include <bits/stdc++.h>

typedef long long ll;
using namespace std;
#define PYMOD(A, M) ((((A) % (M)) + (M)) % (M))

const int hm = 1e9 + 7;
const int hp = 179;

struct hashed_string {
    vector<int> h;
    vector<int> pp;

    hashed_string(const string& t) {
        h.resize(t.size() + 1);
        pp.resize(t.size() + 1);
        h[0] = 0;
        pp[0] = 1;
        for (int i = 0; i < (int)t.size(); i++) {
            h[i + 1] = PYMOD(1ll * h[i] * hp + (t[i] - 'a' + 1), hm);
            pp[i + 1] = PYMOD(1ll * pp[i] * hp, hm);
        }
    }
    
    //[l; r)
    int substr_hash(int l, int r) {
        return PYMOD(h[r] - 1ll * h[l] * pp[r - l], hm);
    }
};

int minimal_period(const string& s) {
    hashed_string h(s);
    for (int k = 1; k <= (int)s.size(); k++) {
        if (s.size() % k == 0) {
            if (h.substr_hash(0, s.size() - k) == h.substr_hash(k, s.size()))
                return k;
        }
    }
    return s.size();
}

ll solve_dumb(const string& s) {
    hashed_string h(s);
    ll ans = 0;
    for (int k = 1; k <= (int)s.size(); k++) {
        unordered_set<int> hh(s.size() - k);
        for (int i = 0; i + k <= (int)s.size(); i++) {
            hh.insert(h.substr_hash(i, i + k));    
        }                                        
        ans += hh.size();
    }
    return ans;
}

ll solve(string s, int n) {
    s = s.substr(0, minimal_period(s));
    int k = s.size();
    
    if (2 * k >= n) {
        return solve_dumb(s + s.substr(0, n - k));
    }

    hashed_string h(s + s);

    ll ans = 0;
    unordered_set<int> hh;
    for (int l = 1; l <= (int)s.size(); l++) {
        for (int i = 0; i + l <= (int)s.size(); i++) {
            hh.insert(h.substr_hash(i, i + l));    
        }
    }
    for (int pfx = 1; pfx < k; pfx++) {
        for (int sfx = 1; pfx + sfx <= k; sfx++) {
            hh.insert(h.substr_hash(k - sfx, k + pfx));     
        }
    }
    ans = hh.size();

    for (int pfx = 0; pfx < k; pfx++) {
        for (int sfx = 0; sfx < k; sfx++) {
            if ((sfx == 0 && pfx != 0) || pfx + sfx > k) {
                if (pfx <= n % k)
                    ans += n / k;
                else
                    ans += n / k - 1;
            } else {
                if (pfx <= n % k)
                    ans += n / k - 1;
                else
                    ans += n / k - 2;
            }
        }
    }
   
    return ans;
}

ll solve_dumb(string s, int n) {
    string t;
    for (int i = 0; i < n; i++)
        t.push_back(s[i % s.size()]);
    return solve_dumb(t);
}

int main() {
    string s;
    int n;
    cin >> s >> n;
    cout << solve(s, n) << endl;     
    return 0;
}