#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 2;
const int MAXN = 2e5 + 3;

int p1[MAXN];
long long sum1[MAXN];
int p2[MAXN];
long long sum2[MAXN];
long long h[MAXN];
int mx[4 * MAXN];
int n;

long long gsum1(int i) {
    if (i == 0) {
        return 0;
    }
    if (sum1[i] == 0) {
        sum1[i] = gsum1(p1[i]) + h[i] * (i - p1[i]);
    }
    return sum1[i];
}

long long gsum2(int i) {
    if (i == n) {
        return 0;
    }
    if (sum2[i] == 0) {
        sum2[i] = gsum2(p2[i]) + h[i] * (p2[i] - i);
    }
    return sum2[i];
}

void init(int l, int r, int i) {
    if (l == r - 1) {
        mx[i] = l;
        return;
    }
    int m = (l + r) / 2;
    init(l, m, 2 * i + 1);
    init(m, r, 2 * i + 2);
    if (h[mx[2 * i + 1]] > h[mx[2 * i + 2]]) {
        mx[i] = mx[2 * i + 1];
    } else {
        mx[i] = mx[2 * i + 2];
    }
}

int gmx(int ql, int qr, int l, int r, int i) {
    //cerr << ql << " " << qr << " " << l << " " << r << "\n";
    if (r <= ql || qr <= l) {
        return n + 1;
    }
    if (ql <= l && r <= qr) {
        return mx[i];
    }
    int m = (l + r) / 2;
    int x1 = gmx(ql, qr, l, m, 2 * i + 1);
    int x2 = gmx(ql, qr, m, r, 2 * i + 2);
    if (h[x1] > h[x2]) return x1;
    return x2;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cin >> n;
    h[0] = INF;
    h[n] = INF;
    h[n + 1] = -1;
    for (int i = 1; i < n; i++) {
       cin >> h[i]; 
    }
    init(1, n, 0);  
    vector<pair<int, int>> vt;
    vt.push_back({h[0], 0});
    for (int i = 1; i < n; i++) {
        while (vt.back().first < h[i]) {
            vt.pop_back();
        }
        p1[i] = vt.back().second;
        vt.push_back({h[i], i});
    }
    vector<pair<int, int>>().swap(vt);
    vt.push_back({h[n], n});
    for (int i = n - 1; i >= 1; i--) {
        while (vt.back().first < h[i]) {
            vt.pop_back();
        }
        p2[i] = vt.back().second;
        vt.push_back({h[i], i});
    }
    
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int a, b;
        cin >> a >> b;
        if (a < b) {
            int g = gmx(a, b, 1, n, 0);
            cout << gsum1(b - 1) - gsum1(p1[g]) << endl;
        } else {
            int g = gmx(b, a, 1, n, 0);
            cout << gsum2(b) - gsum2(p2[g]) << endl;
        }
    }
    return 0;
}