#include <iostream>
#include <cstdlib>
#include <ctime>
#include <map>
#include <random>
#include <algorithm>

using namespace std;

char COLORS[3] = {'R', 'G', 'B'};

const int MAXN = 50010;
const int MAXE = 200010;

vector<pair<int, int>> g[MAXN];
char ans[MAXE];
int in_deg[MAXN];
int n, m;
int used[MAXN];
int dst[MAXN];

void bfs() {
  vector<int> q;
  for (int i = 0; i < n; ++i) {
    if (!in_deg[i]) {
      q.push_back(i);
      dst[i] = 0;
    }
  }

  for (int l = 0; l < (int)q.size(); ++l) {
    int v = q[l];
    for (const auto &p : g[v]) {
      if (!used[p.first]) {
        q.push_back(p.first);
        used[p.first] = 1;
        dst[p.first] = dst[v] + 1;
        ans[p.second] = COLORS[dst[p.first] & 1];
      } else {
        ans[p.second] = COLORS[rand() % 3];
      }
    }
  }
}

int main() {
  srand(time(0));
  scanf("%d%d", &n, &m);
  for (int i = 0; i < m; ++i) {
    int a, b;
    scanf("%d%d", &a, &b);
    --a, --b;
    g[a].push_back({b, i});
    ++in_deg[b];
  }

  bfs();

  for (int i = 0; i < m; ++i) {
    printf("%c\n", ans[i]);
  }
  return 0;
}