#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;

#define X first
#define Y second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()

const ll MOD1 = ll(1e9) + 17;
const ll MOD2 = ll(1e9) + 19;
const ll P = 239;

set<par> hs;

par p[3000];

vector<par> getHS(string &s) {
    vector<par> hs(s.size() + 1);
    hs[0] = {0, 0};
    for (int i = 0; i < s.size(); ++i) {
        hs[i + 1].X = (hs[i].X * P + s[i]) % MOD1;
        hs[i + 1].Y = (hs[i].Y * P + s[i]) % MOD2;
    }
    return hs;
}

par substrH(vector<par> &hs, ll l, ll r) { // [)

    ll res1 = hs[r].X;
    ll h11 = (hs[l].X * p[r - l].X) % MOD1;
    res1 -= h11;
    if (res1 < 0) res1 += MOD1;

    ll res2 = hs[r].Y;
    ll h12 = (hs[l].Y * p[r - l].Y) % MOD2;
    res2 -= h12;
    if (res2 < 0) res1 += MOD2;

    return {res1, res2};
}



void source() {
    p[0] = {1, 1};
    for (int i = 1; i < 3000; ++i) {
        p[i].X = (p[i - 1].X * P) % MOD1;
        p[i].Y = (p[i - 1].Y * P) % MOD2;
    }

    string s;
    cin >> s;
    ll k = s.size();
    ll n;
    cin >> n;

    string tmp = s;
    if (n >= 2 * k)
        tmp += s;
    else
        tmp += s.substr(0, n - k);
    auto p = getHS(tmp);
    set<par> hs;
    for (ll i = 0; i < tmp.size(); ++i) {
        for (ll j = i + 1; j <= tmp.size(); ++j) {
            auto h = substrH(p, i, j);
            hs.insert(h);
        }
    }
    ll ans = hs.size();
    if (n <= 2 * k) {
        cout << ans << endl;
        return;
    }
    tmp = s + "$" + s;
    p = getHS(tmp);
    hs.clear();
    for (ll i = 0; i < k; ++i) {
        for (ll j = k + 1; j <= 2 * k; ++j) {
            hs.insert(substrH(p, i, j));
        }
    }
    ans += hs.size() * ((n - 1) / k - 1);
    cout << ans << endl;
}

int main() {
#ifdef BOSOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);

    source();

#ifdef BOSOV
    cerr << "TIME :: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}